'--- 16F877A PIC met 20 Mhz kristal ---
Device = 16F877A
XTAL = 20

ALL_DIGITAL = true

'--- LEDS ---
Output PORTD.0 
Output PORTD.2
Output PORTD.3

Symbol LED1 = PORTD.0
Symbol LED2 = PORTD.2
Symbol LED3 = PORTD.3

'--- LCD ---
Declare LCD_INTERFACE 4
Declare LCD_LINES 4
Declare LCD_DTPIN PORTB.4
Declare LCD_ENPIN PORTB.2
Declare LCD_RSPIN PORTB.3

Output PORTB.0
PORTB.0 = 0
Symbol LCDLight = PORTB.0

'--- Data in ---
Output PORTA.0
Input PORTE.1
Input PORTE.2
Input PORTC.0

Symbol InReady = PORTA.0
Symbol InPin = PORTE.1

'--- Data Out ---
Input PORTD.1
Output PORTC.3
Output PORTC.2
Output PORTC.1

Symbol OutReady = PORTD.1
Symbol OutPin = PORTC.3
Symbol RTSpin = PORTC.2


'--- ADDRESS ---
Input PORTC.4
Input PORTC.5
Input PORTC.6
Input PORTC.7
Input PORTD.4
Input PORTD.5
Input PORTD.6
Input PORTD.7

Symbol AdresBit1 = PORTC.4
Symbol AdresBit2 = PORTC.5
Symbol AdresBit3 = PORTC.6
Symbol AdresBit4 = PORTC.7
Symbol AdresBit5 = PORTD.4
Symbol AdresBit6 = PORTD.5
Symbol AdresBit7 = PORTD.6
Symbol AdresBit8 = PORTD.7

'--- check address at startup ---
Dim ByteAddress As Byte
ByteAddress = 0
If AdresBit1 = 1 Then
    ByteAddress = ByteAddress + 1
EndIf
If AdresBit2 = 1 Then
    ByteAddress = ByteAddress + 2
EndIf
If AdresBit3 = 1 Then
    ByteAddress = ByteAddress + 4
EndIf
If AdresBit4 = 1 Then
    ByteAddress = ByteAddress + 8
EndIf
If AdresBit5 = 1 Then
    ByteAddress = ByteAddress + 16
EndIf
If AdresBit6 = 1 Then
    ByteAddress = ByteAddress + 32
EndIf
If AdresBit7 = 1 Then
    ByteAddress = ByteAddress + 64
EndIf
If AdresBit8 = 1 Then
    ByteAddress = ByteAddress + 128
EndIf

'--- variables ---
Dim AdressReceive As Byte
Dim NumberOfBytes As Byte
Dim ByteArray [255] As Byte
Dim ByteCounter As Byte
Dim IntY As Byte
Dim IntX As Byte
Dim IntCounter As Byte

'--- turn every output off ---
Low LED1
Low LED2
Low LED3
Low PORTB
Low OutPin
Low InReady
Low RTSpin
DelayMS 200
LCDLight = 0
Print At 1,1,"                    "
Print At 2,1,"                    "
Print At 3,1,"                    "
Print At 4,1,"                    "

'--- MAIN LOOP ---
While 1=1
    '--- wait for incomming data ---
    High LED1
    High InReady
    SerIn InPin,16468,[Wait("A"),AdressReceive]
    High LED2
    SerIn InPin,16468,[Wait("N"),NumberOfBytes]
    Low LED1
    Low InReady
    For ByteCounter = 1 To NumberOfBytes
    SerIn InPin,16468,[Wait("X"),ByteArray[ByteCounter]]
    Next
    Low LED2
    '--- if PCB address = received address, then do some *magic* ---
    '--- this piece of code if different for every type of PCB   ---
    If AdressReceive = ByteAddress Then
        Select Case ByteArray[1]
            '--- LCD light off ---
            Case 0
                LCDLight = 0
            '--- LCD light on ---
            Case 1
                LCDLight = 1
            '--- LCD light off and clear screen ---
            Case 2
                LCDLight = 0
                Print At 1,1,"                    "
                Print At 2,1,"                    "
                Print At 3,1,"                    "
                Print At 4,1,"                    "
            '--- LCD light on and clear screen ---
            Case 3
                LCDLight = 1
                Print At 1,1,"                    "
                Print At 2,1,"                    "
                Print At 3,1,"                    "
                Print At 4,1,"                    "        
        End Select
        If NumberOfBytes > 1 Then
            IntY = ByteArray[2]
            For IntCounter = 4 To NumberOfBytes
                IntX = ByteArray[3] + IntCounter - 4
                Print At IntY,IntX, ByteArray[IntCounter]
            Next
        EndIf
    EndIf
    '--- wait for ready signal from next controller ---
    High RTSpin
    While OutReady = 0
    Wend
    Low RTSpin
    '--- send data to next controller ---
    High LED3
    SerOut OutPin,16468,["A",AdressReceive]
    DelayUS 1
    SerOut OutPin,16468,["N",NumberOfBytes]
    DelayUS 1
    For ByteCounter = 1 To NumberOfBytes
        SerOut OutPin,16468,["X",ByteArray[ByteCounter]]
    Next
    Low LED3 
Wend

