'--- 16F877A PIC met 20 Mhz kristal ---
Device = 16F877A
XTAL = 20

ALL_DIGITAL = true


'--- LEDS ---
Output PORTD.0 
Output PORTD.2
Output PORTD.3

Symbol LED1 = PORTD.0
Symbol LED2 = PORTD.2
Symbol LED3 = PORTD.3

'--- INPUTS ---
Input PORTB.0
Input PORTB.1
Input PORTB.2
Input PORTB.3
Input PORTB.4
Input PORTB.5
Input PORTB.6
Input PORTB.7

Symbol Input1 = PORTB.0
Symbol Input2 = PORTB.1
Symbol Input3 = PORTB.2
Symbol Input4 = PORTB.3
Symbol Input5 = PORTB.4
Symbol Input6 = PORTB.5
Symbol Input7 = PORTB.6
Symbol Input8 = PORTB.7
Symbol InputByte = PORTB

'--- Data in ---
Output PORTA.0
Input PORTE.1
Input PORTE.2
Input PORTC.0

Symbol InReady = PORTA.0
Symbol InPin = PORTE.1
Symbol Incomming = PORTE.2

'--- Data Out ---
Input PORTD.1
Output PORTC.3
Output PORTC.2
Output PORTC.1

Symbol OutReady = PORTD.1
Symbol OutPin = PORTC.3
Symbol RTSpin = PORTC.2


'--- ADDRESS ---
Input PORTC.4
Input PORTC.5
Input PORTC.6
Input PORTC.7
Input PORTD.4
Input PORTD.5
Input PORTD.6
Input PORTD.7

Symbol AdresBit1 = PORTC.4
Symbol AdresBit2 = PORTC.5
Symbol AdresBit3 = PORTC.6
Symbol AdresBit4 = PORTC.7
Symbol AdresBit5 = PORTD.4
Symbol AdresBit6 = PORTD.5
Symbol AdresBit7 = PORTD.6
Symbol AdresBit8 = PORTD.7

'--- check address at startup ---
Dim ByteAddress As Byte
ByteAddress = 0
If AdresBit1 = 1 Then
    ByteAddress = ByteAddress + 1
EndIf
If AdresBit2 = 1 Then
    ByteAddress = ByteAddress + 2
EndIf
If AdresBit3 = 1 Then
    ByteAddress = ByteAddress + 4
EndIf
If AdresBit4 = 1 Then
    ByteAddress = ByteAddress + 8
EndIf
If AdresBit5 = 1 Then
    ByteAddress = ByteAddress + 16
EndIf
If AdresBit6 = 1 Then
    ByteAddress = ByteAddress + 32
EndIf
If AdresBit7 = 1 Then
    ByteAddress = ByteAddress + 64
EndIf
If AdresBit8 = 1 Then
    ByteAddress = ByteAddress + 128
EndIf

'--- variables ---
Dim AdressReceive As Byte
Dim NumberOfBytes As Byte
Dim ByteArray [255] As Byte
Dim ByteCounter As Byte

'--- extra variables ---
Dim IdentCounter As Byte
Dim OldValue As Byte
Dim NewValue As Byte
Dim TmpValue As Byte
Dim LoopCount As Byte
Dim BoolSend As Bit

'--- turn every output off ---
Low LED1
Low LED2
Low LED3
Low PORTB
Low OutPin
Low InReady
Low RTSpin
DelayMS 100

'--- initialise variables ---
NewValue = InputByte
OldValue = NewValue
TmpValue = NewValue
IdentCounter = 0

'--- MAIN LOOP ---
While 1=1

    While Incomming = 0
        NewValue = InputByte

        '--- check for jittering ---
        If NewValue <> OldValue Then
            If NewValue <> TmpValue Then
                TmpValue = NewValue
                IdentCounter = 0
                BoolSend = 0
            Else
                If IdentCounter < 100 Then
                    IdentCounter = IdentCounter + 1
                    BoolSend = 1
                End If
            End If
        Else
            IdentCounter = 0
            BoolSend = 0
        End If

        If BoolSend = 1 And IdentCounter = 100 Then
            ByteArray[1] = NewValue
            OldValue = NewValue
            '--- wait for ready signal from next controller ---
            High RTSpin
            While OutReady = 0
            Wend
            Low RTSpin
            '--- send data to next controller ---
            High LED3
            SerOut OutPin,16468,["A",ByteAddress]
            DelayUS 1
            SerOut OutPin,16468,["N",1]
            DelayUS 1
            SerOut OutPin,16468,["X",ByteArray[1]]
            Low LED3
            BoolSend = 0
        End If
    Wend

    '--- wait for incomming data ---
    High LED1
    High InReady
    SerIn InPin,16468,[Wait("A"),AdressReceive]
    High LED2
    SerIn InPin,16468,[Wait("N"),NumberOfBytes]
    Low LED1
    Low InReady
    For ByteCounter = 1 To NumberOfBytes
    SerIn InPin,16468,[Wait("X"),ByteArray[ByteCounter]]
    Next
    Low LED2

    '--- if PCB address = received address, then do some *magic* ---
    '--- this piece of code if different for every type of PCB   ---
    If AdressReceive = ByteAddress And NumberOfBytes = 1 And ByteArray[1] = "R" Then
        ByteArray[1] = InputByte
    EndIf

    '--- wait for ready signal from next controller ---
    High RTSpin
    While OutReady = 0
    Wend
    Low RTSpin

    '--- send data to next controller ---
    High LED3
    SerOut OutPin,16468,["A",AdressReceive]
    DelayUS 1
    SerOut OutPin,16468,["N",NumberOfBytes]
    DelayUS 1
    For ByteCounter = 1 To NumberOfBytes
        SerOut OutPin,16468,["X",ByteArray[ByteCounter]]
    Next
    Low LED3 
Wend

