'--- 16F877A PIC met 20 Mhz kristal ---
Device = 16F877A
XTAL = 20

ALL_DIGITAL = true


'--- LEDS ---
Output PORTA.0 
Output PORTA.1
Output PORTA.2
Output PORTA.3
Output PORTA.5
Output PORTE.0

Symbol LED1 = PORTA.0
Symbol LED2 = PORTA.1
Symbol LED3 = PORTA.2
Symbol LED4 = PORTA.3
Symbol LED5 = PORTA.5
Symbol LED6 = PORTE.0

'--- RS232 communication with FriendlyARM ---
Input PORTE.1
Input PORTE.2

Symbol DataInPin = PORTE.1
Symbol DataOutPin = PORTE.2

'--- BUS 1 ---
Input PORTC.0
Output PORTC.1
Output PORTC.2
Output PORTC.3

Output PORTD.3
Input PORTD.2
Input PORTD.1

Symbol Bus1OutReady = PORTC.0
Symbol Bus1OutPin = PORTC.1
Symbol Bus1InReady = PORTD.3
Symbol Bus1InPin = PORTD.2
Symbol Bus1RTSPin = PORTD.1

'--- BUS 2 ---
Input PORTC.4
Output PORTC.5
Output PORTC.6
Output PORTC.7

Output PORTD.7
Input PORTD.6
Input PORTD.5

Symbol Bus2OutReady = PORTC.4
Symbol Bus2OutPin = PORTC.5
Symbol Bus2InReady = PORTD.7
Symbol Bus2InPin = PORTD.6
Symbol Bus2RTSPin = PORTD.5

'--- BUS 3 ---
Input PORTB.0
Output PORTB.1
Output PORTB.2
Output PORTB.3

Output PORTB.7
Input PORTB.6
Input PORTB.5

Symbol Bus3OutReady = PORTB.0
Symbol Bus3OutPin = PORTB.1
Symbol Bus3InReady = PORTB.7
Symbol Bus3InPin = PORTB.6
Symbol Bus3RTSPin = PORTB.5

'--- variables ---
Dim InValue As Byte
Dim ByteCounter As Byte
Dim NumberOfBytes As Byte
Dim ByteAddress As Byte
Dim ByteBus As Byte
Dim ByteArray [255] As Byte

Low Bus1OutPin
Low Bus1InReady
Low Bus2OutPin
Low Bus2InReady
Low Bus3OutPin
Low Bus3InReady


GoSub LedInitSeq:

'--- MAIN LOOP ---
While 1=1
    '--- Wait for data to come from FriendlyARM ---
    SerIn DataInPin,84,[Wait("B"),ByteBus]
    '--- depending on B(us)-byte, lit up the corresponding LED ---
    If ByteBus = 1 Then High LED6
    If ByteBus = 2 Then High LED4
    If ByteBus = 3 Then High LED2
    '--- next, receive all data (address, number of bytes, and actual byte(array)) ---
    SerIn DataInPin,84,[Wait("A"),ByteAddress]
    SerIn DataInPin,84,[Wait("N"),NumberOfBytes]
    For ByteCounter = 1 To NumberOfBytes
        SerIn DataInPin,84,[Wait("X"),ByteArray[ByteCounter]]
    Next    

    '--- depending on bus-ID, send data to corresponding bus ---
    '--- logic for bus 1 ---
    If ByteBus = 1 Then
        '--- wait for first PCB to become ready ---
        While Bus1OutReady = 0
        Wend
        '--- turn on data-LED for bus 1 ---
        High LED5
        '--- send data ---
        SerOut Bus1OutPin,16468,["A",ByteAddress]
        DelayUS 1
        SerOut Bus1OutPin,16468,["N",NumberOfBytes]
        DelayUS 1
        For ByteCounter = 1 To NumberOfBytes 
            SerOut Bus1OutPin,16468,["X",ByteArray[ByteCounter]]
            DelayUS 1
        Next
        '--- turn data-LED back off ---
        Low LED5
        '--- wait for response ---
        While Bus1RTSPin = 0
        Wend
        '--- get data from last PCB, and throw it back to FriendlyARM ---
        High LED5
        GoSub Bus1GetData
        Low LED5
        Low LED6     
    EndIf
    
    '--- logic for bus 2 ---
    If ByteBus = 2 Then
        '--- wait for first PCB to become ready ---
        While Bus2OutReady = 0
        Wend
        '--- turn on data-LED for bus 1 ---
        High LED3
        '--- send data ---
        SerOut Bus2OutPin,16468,["A",ByteAddress]
        DelayUS 1
        SerOut Bus2OutPin,16468,["N",NumberOfBytes]
        DelayUS 1
        For ByteCounter = 1 To NumberOfBytes 
            SerOut Bus2OutPin,16468,["X",ByteArray[ByteCounter]]
            DelayUS 1
        Next
        '--- turn data-LED back off ---
        Low LED3
        '--- wait for response ---
        While Bus2RTSPin = 0
        Wend
        '--- get data from last PCB, and throw it back to FriendlyARM ---
        High LED3
        GoSub Bus2GetData
        Low LED3
        Low LED4         
    EndIf
    '--- logic for bus 3 ---
    If ByteBus = 3 Then
        '--- wait for first PCB to become ready ---
        While Bus3OutReady = 0
        Wend
        '--- turn on data-LED for bus 1 ---
        High LED1
        '--- send data ---
        SerOut Bus3OutPin,16468,["A",ByteAddress]
        DelayUS 1
        SerOut Bus3OutPin,16468,["N",NumberOfBytes]
        DelayUS 1
        For ByteCounter = 1 To NumberOfBytes 
            SerOut Bus3OutPin,16468,["X",ByteArray[ByteCounter]]
            DelayUS 1
        Next
        '--- turn data-LED back off ---
        Low LED1
        '--- wait for response ---
        While Bus3RTSPin = 0
        Wend
        '--- get data from last PCB, and throw it back to FriendlyARM ---
        High LED1
        GoSub Bus3GetData
        Low LED1
        Low LED2     
    EndIf
Wend

'--- get data from PCB chain bus 1 ---
Bus1GetData:
    '--- get data from last PCB ---
    High Bus1InReady
    SerIn Bus1InPin,16468,[Wait("A"),ByteAddress]
    SerIn Bus1InPin,16468,[Wait("N"),NumberOfBytes]
    Low Bus1InReady
    For ByteCounter = 1 To NumberOfBytes
        SerIn Bus1InPin,16468,[Wait("X"),ByteArray[ByteCounter]]
    Next
    '--- send data to FriendlyARM ---
    SerOut DataOutPin,84,["B",1]
    SerOut DataOutPin,84,["A",ByteAddress]
    SerOut DataOutPin,84,["N",NumberOfBytes]
    For ByteCounter = 1 To NumberOfBytes
        SerOut DataOutPin,84,["X",ByteArray[ByteCounter]]
    Next
    SerOut DataOutPin,84,["*****"]
Return

'--- get data from PCB chain bus 2 ---
Bus2GetData:
    '--- get data from last PCB ---
    High Bus2InReady
    SerIn Bus2InPin,16468,[Wait("A"),ByteAddress]
    SerIn Bus2InPin,16468,[Wait("N"),NumberOfBytes]
    Low Bus2InReady
    For ByteCounter = 1 To NumberOfBytes
        SerIn Bus2InPin,16468,[Wait("X"),ByteArray[ByteCounter]]
    Next
    '--- send data to FriendlyARM ---
    SerOut DataOutPin,84,["B",2]
    SerOut DataOutPin,84,["A",ByteAddress]
    SerOut DataOutPin,84,["N",NumberOfBytes]
    For ByteCounter = 1 To NumberOfBytes
        SerOut DataOutPin,84,["X",ByteArray[ByteCounter]]
    Next
    SerOut DataOutPin,84,["*****"]
Return

'--- get data from PCB chain bus 3 ---
Bus3GetData:
    '--- get data from last PCB ---
    High Bus3InReady
    SerIn Bus3InPin,16468,[Wait("A"),ByteAddress]
    SerIn Bus3InPin,16468,[Wait("N"),NumberOfBytes]
    Low Bus3InReady
    For ByteCounter = 1 To NumberOfBytes
        SerIn Bus3InPin,16468,[Wait("X"),ByteArray[ByteCounter]]
    Next
    '--- send data to FriendlyARM ---
    SerOut DataOutPin,84,["B",3]
    SerOut DataOutPin,84,["A",ByteAddress]
    SerOut DataOutPin,84,["N",NumberOfBytes]
    For ByteCounter = 1 To NumberOfBytes
        SerOut DataOutPin,84,["X",ByteArray[ByteCounter]]
    Next
    SerOut DataOutPin,84,["*****"]
Return

'--- init sequence with LEDs, to show that system is alive ---
LedInitSeq:

    '--- first, make sure all LEDs are off ---
    Low LED1
    Low LED2
    Low LED3
    Low LED4
    Low LED5
    Low LED6

    '--- turn them on, one by one ---
    High LED1
    DelayMS 200
    High LED2
    DelayMS 200
    High LED3
    DelayMS 200
    High LED4
    DelayMS 200
    High LED5
    DelayMS 200
    High LED6
    DelayMS 200

    '--- turn them off again, one by one ---
    Low LED1
    DelayMS 200
    Low LED2
    DelayMS 200
    Low LED3
    DelayMS 200
    Low LED4
    DelayMS 200
    Low LED5
    DelayMS 200
    Low LED6
    DelayMS 200


Return
