'--- 16F877A PIC met 20 Mhz kristal ---
Device = 16F877A
XTAL = 20

ALL_DIGITAL = true


'--- LEDS ---
Output PORTD.0 
Output PORTD.2
Output PORTD.3

Symbol LED1 = PORTD.0
Symbol LED2 = PORTD.2
Symbol LED3 = PORTD.3

'--- RELAIS ---
Output PORTB.0
Output PORTB.1
Output PORTB.2
Output PORTB.3
Output PORTB.4
Output PORTB.5
Output PORTB.6
Output PORTB.7

Symbol Relais1 = PORTB.0
Symbol Relais2 = PORTB.1
Symbol Relais3 = PORTB.2
Symbol Relais4 = PORTB.3
Symbol Relais5 = PORTB.4
Symbol Relais6 = PORTB.5
Symbol Relais7 = PORTB.6
Symbol Relais8 = PORTB.7

'--- Data in ---
Output PORTA.0
Input PORTE.1
Input PORTE.2
Input PORTC.0

Symbol InReady = PORTA.0
Symbol InPin = PORTE.1

'--- Data Out ---
Input PORTD.1
Output PORTC.3
Output PORTC.2
Output PORTC.1

Symbol OutReady = PORTD.1
Symbol OutPin = PORTC.3


'--- ADDRESS ---
Input PORTC.4
Input PORTC.5
Input PORTC.6
Input PORTC.7
Input PORTD.4
Input PORTD.5
Input PORTD.6
Input PORTD.7

Symbol AdresBit1 = PORTC.4
Symbol AdresBit2 = PORTC.5
Symbol AdresBit3 = PORTC.6
Symbol AdresBit4 = PORTC.7
Symbol AdresBit5 = PORTD.4
Symbol AdresBit6 = PORTD.5
Symbol AdresBit7 = PORTD.6
Symbol AdresBit8 = PORTD.7

'--- check address at startup ---
Dim ByteAddress As Byte
ByteAddress = 0
If AdresBit1 = 1 Then
    ByteAddress = ByteAddress + 1
EndIf
If AdresBit2 = 1 Then
    ByteAddress = ByteAddress + 2
EndIf
If AdresBit3 = 1 Then
    ByteAddress = ByteAddress + 4
EndIf
If AdresBit4 = 1 Then
    ByteAddress = ByteAddress + 8
EndIf
If AdresBit5 = 1 Then
    ByteAddress = ByteAddress + 16
EndIf
If AdresBit6 = 1 Then
    ByteAddress = ByteAddress + 32
EndIf
If AdresBit7 = 1 Then
    ByteAddress = ByteAddress + 64
EndIf
If AdresBit8 = 1 Then
    ByteAddress = ByteAddress + 128
EndIf

'--- variables ---
Dim AdressReceive As Byte
Dim NumberOfBytes As Byte
Dim ByteArray [255] As Byte
Dim ByteCounter As Byte

'--- turn every output off ---
Low LED1
Low LED2
Low LED3
Low PORTB
Low OutPin
Low InReady
DelayMS 100

'--- MAIN LOOP ---
While 1=1
    '--- wait for incomming data ---
    High LED1
    High InReady
    SerIn InPin,16468,[Wait("AD"),AdressReceive]
    High LED2
    SerIn InPin,16468,[Wait("NB"),NumberOfBytes]
    Low LED1
    Low InReady
    For ByteCounter = 1 To NumberOfBytes
    SerIn InPin,16468,[Wait("X"),ByteArray[ByteCounter]]
    Next
    Low LED2
    '--- if PCB address = received address, then do some *magic* ---
    '--- this piece of code if different for every type of PCB   ---
    If AdressReceive = ByteAddress Then
        PORTB = ByteArray[1]
    EndIf
    '--- wait for ready signal from next controller ---
    While OutReady = 0
    Wend
    '--- send data to next controller ---
    High LED3
    SerOut OutPin,16468,["AD",AdressReceive]
    DelayMS 1
    SerOut OutPin,16468,["NB",NumberOfBytes]
    DelayMS 1
    For ByteCounter = 1 To NumberOfBytes
        SerOut OutPin,16468,["X",ByteArray[ByteCounter]]
    Next
    Low LED3 
Wend

