'--- 16F877A PIC met 20 Mhz kristal ---
Device = 16F877A
XTAL = 20

ALL_DIGITAL = true

'--- LEDS ---
Output PORTD.0 
Output PORTD.2
Output PORTD.3

Symbol LED1 = PORTD.0
Symbol LED2 = PORTD.2
Symbol LED3 = PORTD.3

'--- ADDRESS ---
Input PORTC.4
Input PORTC.5
Input PORTC.6
Input PORTC.7
Input PORTD.4
Input PORTD.5

'---RS232 test ---
Output PORTA.0
Low PORTA.0

Symbol AdresBit1 = PORTC.4
Symbol AdresBit2 = PORTC.5
Symbol AdresBit3 = PORTC.6
Symbol AdresBit4 = PORTC.7
Symbol AdresBit5 = PORTD.4
Symbol AdresBit6 = PORTD.5

'--- type of wireless ---
'    0 = repeater
'    1 = from wired to wireless
'    2 = from wireless to wired
Input PORTD.6
Input PORTD.7

Symbol TypeBit1 = PORTD.6
Symbol TypeBit2 = PORTD.7

'--- check address at startup ---
Dim ByteAddress As Byte
ByteAddress = 0
If AdresBit1 = 1 Then
    ByteAddress = ByteAddress + 1
EndIf
If AdresBit2 = 1 Then
    ByteAddress = ByteAddress + 2
EndIf
If AdresBit3 = 1 Then
    ByteAddress = ByteAddress + 4
EndIf
If AdresBit4 = 1 Then
    ByteAddress = ByteAddress + 8
EndIf
If AdresBit5 = 1 Then
    ByteAddress = ByteAddress + 16
EndIf
If AdresBit6 = 1 Then
    ByteAddress = ByteAddress + 32
EndIf

'--- variables ---
Dim AdressReceive As Byte
Dim NumberOfBytes As Byte
Dim ByteArray [255] As Byte
Dim ByteCounter As Byte
Dim IntCounter As Byte
Dim IntWait As Byte
Dim Nspi As Byte
Dim DdataOut As Word
Dim DdataIn As Word

'--- turn every output off ---
Low LED1
Low LED2
Low LED3
DelayMS 200
'SerOut PORTA.0,84,["Serial Transceiver"]
SerOut PORTA.0,32,["Serial Transceiver"]

'--- RFM12 SPI connection ---
Output PORTB.5
Output PORTB.4
Output PORTB.2
Input PORTB.3
Symbol CLK = PORTB.2
Symbol SDI = PORTB.3
Symbol SDO = PORTB.4
Symbol NSEL = PORTB.5
'--- eventueel SDI & SDO omdraaien ! ---

High LED1
'--- define RFM12 parameters at startup ---
NSEL = 1
CLK = 0

DelayMS 200

DdataOut = $80e7:GoSub SPI16
DdataOut = $82d9:GoSub SPI16
DdataOut = $a67c:GoSub SPI16
DdataOut = $c647:GoSub SPI16
'DdataOut = $94a4:GoSub SPI16
DdataOut = $94a0:GoSub SPI16
DdataOut = $c2ac:GoSub SPI16
DdataOut = $ca81:GoSub SPI16
DdataOut = $c483:GoSub SPI16
'DdataOut = $9850:GoSub SPI16
DdataOut = $9854:GoSub SPI16
DdataOut = $e000:GoSub SPI16
DdataOut = $c800:GoSub SPI16
DdataOut = $c000:GoSub SPI16

'--- MAIN LOOP ---
While 1=1
    GoSub RECEIVE_RFM12
Wend


'---------------------------------------------
'--- WAIT FOR RFM12 MODULE TO BECOME READY ---
'---------------------------------------------
WAIT_RFM12:
    NSEL = 0
    While SDI=0
    Wend
Return

'----------------------------------------
'--- RECEIVE ACTUAL DATA OVER THE AIR ---
'----------------------------------------
RECEIVE_RFM12:
    LED3 = 0
    LED2 = 0
    LED1 = 0
    DdataOut = $82c8:GoSub SPI16
    DdataOut = $ca83:GoSub SPI16
    For IntCounter = 1 To 50
        GoSub WAIT_RFM12
        DdataOut = $B000:GoSub SPI16
        ByteArray[IntCounter] = DdataIn
    Next IntCounter
    For IntCounter = 1 To 50
        SerOut PORTA.0,32,[ByteArray[IntCounter]]
    Next IntCounter
Return

'-------------------------------------
'--- SEND ACTUAL DATA OVER THE AIR ---
'-------------------------------------
SEND_RFM12:

    DdataOut = $8238:GoSub SPI16:GoSub WAIT_RFM12
    DdataOut = $b8aa:GoSub SPI16:GoSub WAIT_RFM12
    DdataOut = $b8aa:GoSub SPI16:GoSub WAIT_RFM12
    DdataOut = $b8aa:GoSub SPI16:GoSub WAIT_RFM12
    DdataOut = $b82d:GoSub SPI16:GoSub WAIT_RFM12
    DdataOut = $b8d4:GoSub SPI16

    For IntCounter = 1 To 10
        GoSub WAIT_RFM12
        DdataOut = $B800 + IntCounter
        GoSub SPI16
    Next IntCounter
  
    GoSub WAIT_RFM12
    DdataOut = $b8aa:GoSub SPI16:GoSub WAIT_RFM12
    DdataOut = $b8aa:GoSub SPI16:GoSub WAIT_RFM12
    DdataOut = $8208:GoSub SPI16
Return


'----------------------------------------------
'--- SPI COMMUNICATION TO/FROM RFM12 MODULE ---
'----------------------------------------------
SPI16:

 '   NSEL = 0
 '   SHOut SDO,CLK,msbfirst,[DdataOut\16]
 '   NSEL = 1

    NSEL = 0
    DdataIn = 0
    For Nspi = 15 To 0 Step -1
        If GetBit DdataOut,Nspi = 0 Then
            SDO = 0
        Else
            SDO = 1
        EndIf
        DdataIn = DdataIn * 2
        DdataIn = DdataIn + SDI        
        CLK = 1
        DelayUS 5
        CLK = 0
        DelayUS 1
    Next Nspi
    NSEL = 1
    DdataIn = DdataIn - $FF00
    DelayUS 2
Return
        
    
